stages:
  - validate
  - plan
  - deploy
  - destroy

validade-prd:
  stage: validate
  image: 
    name: hashicorp/terraform:light
    entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  script:
    - cd terraform
    - terraform init -force-copy
    - terraform validate
  
  environment:
    name: production

plan-prd:
  stage: plan
  image: 
    name: hashicorp/terraform:light
    entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  script:
    - cd terraform
    - terraform init -force-copy
    - terraform plan -out "planfile.pln"
  artifacts:
      untracked: true
      paths:
       - ./planfile.pln
      when: always
  environment:
    name: production
  only:
  - master
  
deploy-prd:
  stage: deploy
  image: 
    name: hashicorp/terraform:light
    entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  when: manual
  script:
    - cd terraform
    - terraform init -force-copy
    - terraform apply -input=false "planfile.pln"
  environment:
    name: production
  only:
  - master
  
destroy-prd:
  stage: destroy
  image: 
    name: hashicorp/terraform:light
    entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  when: manual  
  script:
    - cd terraform
    - terraform init -force-copy
    - terraform destroy -auto-approve
  environment:
    name: production
  only:
  - master




